import c4d
from c4d import utils

# 1.1 - César Vonc

def main():
    objs = doc.GetActiveObjects(c4d.GETACTIVEOBJECTFLAGS_0)
    if not objs : return
    objets = []
    objets_pos = []
    
    for o in objs :
        cache = o.GetDeformCache() or o.GetCache() or o
        cache = cache.GetDeformCache() or cache
        objets_pos.append(o.GetMg())
        objets.append(cache)
    
    retour = utils.SendModelingCommand(command=c4d.MCOMMAND_CURRENTSTATETOOBJECT, list=objets, doc=doc)
    retour.reverse()
    objets_pos.reverse()
    
    doc.StartUndo()
    doc.SetActiveObject(None)
    for n, obj in enumerate(retour) :
        doc.InsertObject(obj)
        doc.SetActiveObject(obj, c4d.SELECTION_ADD)
        pos = objets_pos[n]
        obj.SetMg(pos)
        doc.AddUndo(c4d.UNDOTYPE_NEW, obj)
        
    doc.EndUndo()
    c4d.EventAdd()

if __name__=='__main__':
    main()
